#include <krabwidget.h>

#define ktr		klocale->translate
#define SEP		KTabListBox_todo->separator()

KrabWidget::KrabWidget(QWidget *parent, const char *name, TodoList *todolist_p) : QWidget(parent, name)
{ 
        unsigned int i;

 	todolist = todolist_p;
	for ( i=0; i<6; i++)
	{
	  write_job_track[i] = 0;
	  write_prog[i] = NULL;
	  write_prog_final_size[i] = 0;
        };
        read_prog = NULL;
        help_prog = NULL;
	QCheckBox_wav_raw = NULL;

	iloader  = kapp->getIconLoader();
	pix_cdda = new QPixmap( iloader->loadIcon("cdda.xpm") );
	pix_wav  = new QPixmap( iloader->loadIcon("wav.xpm") );
	pix_mp2  = new QPixmap( iloader->loadIcon("mp2.xpm") );
	pix_mp3  = new QPixmap( iloader->loadIcon("mp3.xpm") );
	pix_push_1 = new QPixmap( iloader->loadIcon("button_1.xpm") );
	pix_push_2 = new QPixmap( iloader->loadIcon("button_2.xpm") );
	pix_push_3 = new QPixmap( iloader->loadIcon("button_3.xpm") );
	pix_push_4 = new QPixmap( iloader->loadIcon("button_4.xpm") );
	pix_push_1_off = new QPixmap( iloader->loadIcon("button_1_o.xpm") );
	pix_push_2_off = new QPixmap( iloader->loadIcon("button_2_o.xpm") );
	pix_push_3_off = new QPixmap( iloader->loadIcon("button_3_o.xpm") );
	pix_push_4_off = new QPixmap( iloader->loadIcon("button_4_o.xpm") );

	initMetaObject();
	initLayout();

	connect( KSlider_nice, SIGNAL(valueChanged(int)), SLOT(KSlider_nice_moved(int)) );
	connect( KSlider_smp, SIGNAL(valueChanged(int)), SLOT(KSlider_smp_moved(int)) );
	connect( KTabListBox_todo, SIGNAL(headerClicked(int)), SLOT( todolist_update() ) );
	connect( QComboBox_cdda, SIGNAL(activated(int)), SLOT(QComboBox_cdda_clicked(int)) );
	connect( QComboBox_encoder, SIGNAL(activated(int)), SLOT(QComboBox_encoder_clicked(int)) );
	connect( QCheckBox_cdda_jitter, SIGNAL(clicked()), SLOT(QCheckBox_cdda_jitter_clicked()) );
	connect( QCheckBox_cdda_stereo, SIGNAL(clicked()), SLOT(QCheckBox_cdda_stereo_clicked()) );
 	connect( QCheckBox_cdda_16bit, SIGNAL(clicked()), SLOT(QCheckBox_cdda_16bit_clicked()) );
	connect( QPushButton_cd, SIGNAL(clicked()), SLOT(cddalister()) );
	connect( QPushButton_doit, SIGNAL(clicked()), SLOT(doit(  )) );
 	connect( QPushButton_outputpath, SIGNAL(clicked()), SLOT(define_outputpath(  )) );
 	connect( QPushButton_names, SIGNAL(clicked()), SLOT(define_names(  )) );
	connect( new KDNDDropZone(this, 0), SIGNAL( dropAction( KDNDDropZone *) ), SLOT( DropEvent(  KDNDDropZone *) ) );

	kconfig = kapp->getConfig();
	kconfig->setGroup("krabber");
	cdparanoia = kconfig->readBoolEntry( "cdparanoia", FALSE );
	cdda2wav = kconfig->readBoolEntry( "cdda2wav", FALSE );
	amp = kconfig->readBoolEntry( "amp", FALSE );
	hz8_mp3 = kconfig->readBoolEntry( "8hz_mp3", FALSE );
	bladeenc = kconfig->readBoolEntry( "bladeenc", FALSE );
	l3enc = kconfig->readBoolEntry( "l3enc", FALSE );
	mp3enc = kconfig->readBoolEntry( "mp3enc", FALSE );
test_enviroment( FALSE );
	QComboBox_encoder->setCurrentItem( kconfig->readNumEntry( "encoder", 0 ) );
	QComboBox_encoder_clicked( kconfig->readNumEntry( "encoder", 0 ) );
	QCheckBox_cdda_stereo->setChecked( kconfig->readBoolEntry( "cdda_stereo", TRUE ) );
	QCheckBox_cdda_stereo_clicked();
	QCheckBox_cdda_16bit->setChecked( kconfig->readBoolEntry( "cdda_16bit", TRUE ) );
	QCheckBox_cdda_16bit_clicked();
	QCheckBox_cdda_jitter->setChecked( kconfig->readBoolEntry( "cdda_jitter", FALSE ) );
	QCheckBox_cdda_jitter_clicked();
	QCheckBox_mp3_header->setChecked( kconfig->readBoolEntry( "mp3_header", TRUE ) );
	KSlider_nice->setValue( 19 - kconfig->readNumEntry( "nice_level", 19 ) );
// ******************** PROBLEM:
	KSlider_nice_moved( 19 - kconfig->readNumEntry( "nice_level", 19 ) );
	KSlider_smp->setValue( kconfig->readNumEntry( "smp_process", 1 ) );
	KSlider_smp_moved( kconfig->readNumEntry( "smp_process", 1 ) );
	QComboBox_cdda->setCurrentItem( kconfig->readNumEntry( "cdda", 8 ) );
	QComboBox_cdda_clicked( kconfig->readNumEntry( "cdda", 8 ) );
	QComboBox_device->setCurrentItem( kconfig->readUnsignedNumEntry( "device", 0 ) );	
	todolist->outputPath = kconfig->readEntry( "outputpath", "/tmp" );	
	todolist->create_dir_group = kconfig->readBoolEntry( "name_create_gdir", FALSE );
	todolist->create_dir_album = kconfig->readBoolEntry( "name_create_adir", FALSE );
};

KrabWidget::~KrabWidget() 
{
	kconfig->setGroup("krabber");
	kconfig->writeEntry( "cdparanoia", cdparanoia );
	kconfig->writeEntry( "cdda2wav", cdda2wav );
	kconfig->writeEntry( "amp", amp );
	kconfig->writeEntry( "8hz_mp3", hz8_mp3 );
	kconfig->writeEntry( "bladeenc", bladeenc );
	kconfig->writeEntry( "l3enc", l3enc );
	kconfig->writeEntry( "mp3enc", mp3enc );
	kconfig->writeEntry( "cdda_stereo", QCheckBox_cdda_stereo->isChecked() );
	kconfig->writeEntry( "cdda_16bit", QCheckBox_cdda_16bit->isChecked() );
	kconfig->writeEntry( "cdda_jitter", QCheckBox_cdda_jitter->isChecked() );
	kconfig->writeEntry( "mp3_header", QCheckBox_mp3_header->isChecked() );
	kconfig->writeEntry( "nice_level", nice_level );
	kconfig->writeEntry( "smp_process", encoder_max );
	kconfig->writeEntry( "cdda", QComboBox_cdda->currentItem() );
	kconfig->writeEntry( "encoder", QComboBox_encoder->currentItem() );
	kconfig->writeEntry( "device", QComboBox_device->currentItem() );
	kconfig->writeEntry( "outputpath", todolist->outputPath );
	kconfig->writeEntry( "name_create_gdir", todolist->create_dir_group );
	kconfig->writeEntry( "name_create_adir", todolist->create_dir_album );
	if ( todolist->grab_mode == 0 )
	{
		kconfig->writeEntry( "wav_data_raw", QCheckBox_wav_raw->isChecked() );
	}
	if ( todolist->grab_mode == 2 )
	{
		kconfig->writeEntry( "8hz_enc_br", QComboBox_8hz_br->currentItem() );
		kconfig->writeEntry( "8hz_enc_copyright", QCheckBox_8hz_copyright->isChecked() );
		kconfig->writeEntry( "8hz_enc_original", QCheckBox_8hz_original->isChecked() );
	};
	if ( todolist->grab_mode == 3 )
	{
		kconfig->writeEntry( "l3_enc_br", QComboBox_l3_br->currentItem() );
		kconfig->writeEntry( "l3_enc_hq", QCheckBox_l3_hq->isChecked() );
		kconfig->writeEntry( "l3_enc_speech", QCheckBox_l3_speech->isChecked() );
		kconfig->writeEntry( "l3_enc_crc", QCheckBox_l3_crc->isChecked() );
	};
	if ( todolist->grab_mode == 4 )
	{
		kconfig->writeEntry( "mp3_enc_br", QComboBox_mp3_br->currentItem() );
		kconfig->writeEntry( "mp3_enc_ql", QComboBox_mp3_ql->currentItem() );
	};
	if ( todolist->grab_mode == 5 )
	{
		kconfig->writeEntry( "blade_enc_br", QComboBox_blade_br->currentItem() );
		kconfig->writeEntry( "blade_enc_copyright", QCheckBox_blade_copyright->isChecked() );
		kconfig->writeEntry( "blade_enc_private", QCheckBox_blade_private->isChecked() );
		kconfig->writeEntry( "blade_enc_crc", QCheckBox_blade_crc->isChecked() );
	};
	kconfig->sync();
};

void KrabWidget::resizeEvent( QResizeEvent * )
{
	QFrame_controll->setGeometry( (width() - 299) ,4 ,297, 421);
	KTabListBox_todo->setGeometry( 4 ,4 , ( width() - 310) , (height()-10) );
//	KTabListBox_todo->updateScrollBars();
};

void KrabWidget::KSlider_nice_moved(int temp)
{
	nice_level = 19 - temp;
}

void KrabWidget::KSlider_smp_moved(int temp)
{
	encoder_max = temp;
}
void KrabWidget::select_files()
{
	krabwidget_setEnabled( FALSE );
	QString temp = KFileDialog::getOpenFileName(todolist->outputPath, "*.mp2 *.mp3 *.wav *.MP2 *.MP3 *.WAV", this, "Open"); 
	if ( temp != "" )
		select_file( temp );
	todolist_update();
	krabwidget_setEnabled( TRUE );
};
void KrabWidget::define_names()
{
	if ( todolist->tracks == 0 )
	{
		KMsgBox::message( this, ktr( "Error" ), ktr( "Select some tracks or files first ! \n") );
		return;
	};
	krabwidget_setEnabled( FALSE );
	NameWidget = new namewidget( 0, "", todolist );

	NameWidget->QComboBox_file_1->setCurrentItem( kconfig->readNumEntry( "name_combo_file_1", 2 ) );
	NameWidget->QComboBox_file_2->setCurrentItem( kconfig->readNumEntry( "name_combo_file_2", 6 ) );
	NameWidget->QComboBox_file_3->setCurrentItem( kconfig->readNumEntry( "name_combo_file_3", 0 ) );
	NameWidget->QComboBox_file_4->setCurrentItem( kconfig->readNumEntry( "name_combo_file_4", 0 ) );
	NameWidget->QComboBoxType->setCurrentItem( kconfig->readNumEntry( "name_combotype", 0 ) );
	NameWidget->QLineEdit_file_1->setText( kconfig->readEntry( "name_line_file_1", ". " ) );
	NameWidget->QLineEdit_file_2->setText( kconfig->readEntry( "name_line_file_2", "" ) );
	NameWidget->QLineEdit_file_3->setText( kconfig->readEntry( "name_line_file_3", "" ) );
	if ( todolist->grab_mode == 0 )
	{
		if ( QCheckBox_wav_raw->isChecked() )
			NameWidget->QLineEdit_file_4->setText( ".cdr" );
		else
			NameWidget->QLineEdit_file_4->setText( ".wav" );
	}
	else
		NameWidget->QLineEdit_file_4->setText(  ".mp3" );

       	connect( NameWidget, SIGNAL(destroy_namewidget()), SLOT(NameWidgetDestroyed()) );
	NameWidget->show();
};

void KrabWidget::NameWidgetDestroyed()
{
	krabwidget_setEnabled( TRUE );
	kconfig->writeEntry( "name_combo_file_1", NameWidget->QComboBox_file_1->currentItem() );
	kconfig->writeEntry( "name_combo_file_2", NameWidget->QComboBox_file_2->currentItem() );
	kconfig->writeEntry( "name_combo_file_3", NameWidget->QComboBox_file_3->currentItem() );
	kconfig->writeEntry( "name_combo_file_4", NameWidget->QComboBox_file_4->currentItem() );
	kconfig->writeEntry( "name_combotype", NameWidget->QComboBoxType->currentItem() );
	kconfig->writeEntry( "name_line_file_1", NameWidget->QLineEdit_file_1->text() );
	kconfig->writeEntry( "name_line_file_2", NameWidget->QLineEdit_file_2->text() );
	kconfig->writeEntry( "name_line_file_3", NameWidget->QLineEdit_file_3->text() );
	kconfig->writeEntry( "name_line_file_4", NameWidget->QLineEdit_file_4->text() );
	kconfig->sync();
	delete NameWidget;
	todolist_update();
};

void KrabWidget::define_outputpath()
{
	QString temp;
	krabwidget_setEnabled( FALSE );
	temp = KFileDialog::getOpenFileName(todolist->outputPath, ".", this, "Open"); 
//	todolist->outputPath = QFileDialog::getExistingDirectory( todolist->outputPath, this, "test");
	if ( temp != "" )
		todolist->outputPath = temp;
	krabwidget_setEnabled( TRUE );
};


void KrabWidget::DropEvent(KDNDDropZone *zone)
{
	QString temp;
	unsigned int i, count;
	char *url_p;

	count = zone->getURLList().count();

	for ( i=0; i < count; i++ )
	{
		if ( i == 0) 
			url_p = zone->getURLList().first();
		else
			url_p = zone->getURLList().next();

		if ( *url_p !=  'f' || *(url_p+1) != 'i' )
		{
			sorry(); return ;
		};
		
		url_p = url_p + 5;
		temp = url_p;
		select_file( temp, (i+1) );
	};
	todolist_update();
}

void KrabWidget::select_file(QString file_name, unsigned int tracknr=0 )
{
	unsigned int size;
	char ident[5], convert[6], mp2[5], mp3[5], wav[5];
	QString temp;
	QFile file;
        char *ident_p = ident;
	ident = "AAAA";

	wav[0] = 'R';
	wav[1] = 'I';
	wav[2] = 'F';
	wav[3] = 'F';
	wav[4] = 0;
	mp3[0] = 255;
	mp3[1] = 251;
	mp3[2] = 250;
	mp2[0] = 255;
	mp2[1] = 253;
	mp2[2] = 252;

	file.setName(file_name);
	if ( !file.open( IO_ReadOnly ) )
		return;
	size = file.size();
	file.readBlock( ident_p, 4 );
	ident[4] = '\0';
	if ( ident[0] == mp2[0] && (ident[1]==mp2[1]||ident[1]==mp2[2]) )
	{		
		if ( amp )
		{
			todolist->tracks++;
			todolist->type[todolist->tracks]=2;
			todolist->device[todolist->tracks] = file_name;
			todolist->time[todolist->tracks] = "";
			todolist->tracknumber[todolist->tracks]=tracknr;
			todolist->year[todolist->tracks] = "";
			todolist->group[todolist->tracks] = "";
			todolist->album[todolist->tracks] = "";
			todolist->title[todolist->tracks] = "";
			todolist->comment[todolist->tracks] = "";
			todolist->type[todolist->tracks] = 2;
			todolist->music_type[todolist->tracks] = 0;
			ostrstream( convert, 5) << todolist->tracks << ends;
			temp = convert;
			if ( todolist->tracks< 10 )
				temp = "0" + temp;
			todolist->output_filename[todolist->tracks] = "KrabberFile" + temp;               
			if ( ((ident[3]>>6)&0x3) != 3 )
				size = 2 * size;
			size = size / ( bitrate_mpeg_layer2[(ident[2] >> 4) & 0x0F] * 128 ) ;
			if (((ident[2] >> 2)&0x3) == 0 )
				todolist->nodes[todolist->tracks]= (size * 44100 * 2) / 2048;
			if (((ident[2] >> 2)&0x3) == 1 )
				todolist->nodes[todolist->tracks]= (size * 48000 * 2) / 2048;
			if (((ident[2] >> 2)&0x3) == 2 )
				todolist->nodes[todolist->tracks]= (size * 32000 * 2) / 2048;
		}
		else
			KMsgBox::message( this, ktr( "Error" ), ktr( "You need the amp ...\n") );
	}
	else if ( ident[0] == mp3[0] && (ident[1]==mp3[1]||ident[1]==mp3[2]) )
	{
		if ( amp )
		{
			todolist->tracks++;
			todolist->type[todolist->tracks]=3;
			todolist->device[todolist->tracks] = file_name;
			todolist->time[todolist->tracks] = "";
			todolist->tracknumber[todolist->tracks]=tracknr;
			todolist->year[todolist->tracks] = "";
			todolist->group[todolist->tracks] = "";
			todolist->album[todolist->tracks] = "";
			todolist->title[todolist->tracks] = "";
			todolist->comment[todolist->tracks] = "";
			todolist->type[todolist->tracks] = 3;
			todolist->music_type[todolist->tracks] = 0;
			ostrstream( convert, 5) << todolist->tracks << ends;
			temp = convert;
			if ( todolist->tracks< 10 )
				temp = "0" + temp;
			todolist->output_filename[todolist->tracks] = "KrabberFile" + temp;
			if ( ((ident[3]>>6)&0x3) != 3 )
				size = 2 * size;
			size = size / ( bitrate_mpeg_layer3[(ident[2] >> 4) & 0x0F] * 128 ) ;
			if (((ident[2] >> 2)&0x3) == 0 )
				todolist->nodes[todolist->tracks]= (size * 44100 * 2) / 2048;
			if (((ident[2] >> 2)&0x3) == 1 )
				todolist->nodes[todolist->tracks]= (size * 48000 * 2) / 2048;
			if (((ident[2] >> 2)&0x3) == 2 )
				todolist->nodes[todolist->tracks]= (size * 32000 * 2) / 2048;
		}
		else
			KMsgBox::message( this, ktr( "Error" ), ktr( "You need the amp ...\n") );
	}
	else if ( ident[0] == wav[0] && ident[1] == wav[1] && ident[2] == wav[2] && ident[3] == wav[3] ) 
	{
		todolist->tracks++;
		todolist->type[todolist->tracks]=4;
		todolist->device[todolist->tracks] = file_name;
		todolist->time[todolist->tracks] = "";
		todolist->tracknumber[todolist->tracks]=tracknr;
		todolist->year[todolist->tracks] = "";
		todolist->group[todolist->tracks] = "";
		todolist->album[todolist->tracks] = "";
		todolist->title[todolist->tracks] = "";
		todolist->comment[todolist->tracks] = "";
		todolist->type[todolist->tracks] = 4;
		todolist->music_type[todolist->tracks] = 0;
		ostrstream( convert, 5) << todolist->tracks << ends;
		temp = convert;
		if ( todolist->tracks< 10 )
			temp = "0" + temp;
		todolist->output_filename[todolist->tracks] = "KrabberFile" + temp;
		todolist->nodes[todolist->tracks] = size/2048;
	}
	else 
	{
		;
	};
	file.close();
};

void KrabWidget::todolist_update()
{
	unsigned int i;
	char line[1024];
	KTabListBox_todo->clear();
	KTabListBox_todo->setSeparator( '@' );
	KTabListBox_todo->setAutoUpdate(FALSE);
	KTabListBox_todo->clear();
	for (i = 1; i <= todolist->tracks; i++)
	{
		if ( todolist->type[ i ] == 1 )
			ostrstream( line, 1024 ) << "CDDA" <<SEP<< i <<SEP<< todolist->tracknumber[i]
				<<SEP<<todolist->device[i]<<SEP<< ((todolist->nodes[i])/512) <<SEP<<" "
				<< todolist->group[i] <<SEP<<" "<< todolist->album[i]<<SEP<<" "<<todolist->title[i]
				<<SEP<<" "<<todolist->output_filename[i] <<ends;
		if ( todolist->type[ i ] == 2 )
			ostrstream( line, 1024 ) << "MP2" <<SEP<< i <<SEP <<todolist->tracknumber[i] << SEP <<" "
				<<todolist->device[i]<<SEP<<SEP<< ((todolist->nodes[i])/512) <<SEP<< " "
				<< todolist->group[i] <<SEP<<" "<< todolist->album[i]<<SEP<<" "<<todolist->title[i]
				<<SEP<<" "<<todolist->output_filename[i] <<ends;
		if ( todolist->type[ i ] == 3 )
			ostrstream( line, 1024 ) << "MP3" <<SEP<< i <<SEP <<todolist->tracknumber[i] << SEP <<" "
				<<todolist->device[i]<<SEP<<SEP<< ((todolist->nodes[i])/512) <<SEP<< " "
				<< todolist->group[i] <<SEP<<" "<< todolist->album[i]<<SEP<<" "<<todolist->title[i]
				<<SEP<<" "<<todolist->output_filename[i] <<ends;
		if ( todolist->type[ i ] == 4 )
			ostrstream( line, 1024 ) << "WAV" <<SEP<< i <<SEP <<todolist->tracknumber[i] << SEP <<" "
				<<todolist->device[i]<<SEP<<SEP<< ((todolist->nodes[i])/512) <<SEP<< " "
				<< todolist->group[i] <<SEP<<" "<< todolist->album[i]<<SEP<<" "<<todolist->title[i]
				<<SEP<<" "<<todolist->output_filename[i] <<ends;
		KTabListBox_todo->insertItem(line);
		KTabListBox_todo->dict().replace( "CDDA", pix_cdda );
		KTabListBox_todo->dict().replace( "WAV",  pix_wav );
		KTabListBox_todo->dict().replace( "MP2",  pix_mp2 );
		KTabListBox_todo->dict().replace( "MP3",  pix_mp3 );
	};
	KTabListBox_todo->setAutoUpdate(TRUE);
	KTabListBox_todo->update();
	KTabListBox_todo->repaint();
};

void KrabWidget::CddaListDestroyed()
{
	krabwidget_setEnabled( TRUE );
       	disconnect( CddaList, SIGNAL(destroy_cddalist()) );
 	delete CddaList;
	todolist_update();
};


void KrabWidget::cddalister()
{
	krabwidget_setEnabled( FALSE );
	todolist->device_choiced = QComboBox_device->text(QComboBox_device->currentItem()); 	
	CddaList = new cddalist( 0, "", todolist);
       	connect( CddaList, SIGNAL(destroy_cddalist()), SLOT(CddaListDestroyed()) );
//     	connect( CddaList, SIGNAL(destroyed()), SLOT(CddaListDestroyed()) );
	CddaList->show();
	if ( todolist->tracks_cdda == 0 )
	{
		delete CddaList;
		krabwidget_setEnabled( TRUE );
		todolist_update();
	};
};

void KrabWidget::QComboBox_cdda_clicked(int z)
{
	QString temp;
	z = z; // I hate compiler warnings...
	if ( todolist->grab_mode == 2 && (QComboBox_cdda->currentItem() != 8) )
	{
		KMsgBox::message( this, ktr ( "Error" ), ktr ( "If you want to use the 8hz-mp3 encoder you MUST grab with 44100 ! " ), 2);  	
 		QComboBox_cdda->setCurrentItem( 8 );	
	}
	if ( todolist->grab_mode == 5 && (QComboBox_cdda->currentItem() != 8) )
	{
		KMsgBox::message( this, ktr ( "Error" ), ktr ( "If you want to use the blade encoder you MUST grab with 44100 ! " ), 2);  	
 		QComboBox_cdda->setCurrentItem( 8 );	
	}
	if ( todolist->grab_mode == 3 && !((QComboBox_cdda->currentItem() == 8) || (QComboBox_cdda->currentItem() == 7) || (QComboBox_cdda->currentItem() == 5) ) )
	{
		KMsgBox::message( this, ktr ( "Error" ), ktr ( "If you want to use the l3enc encoder you MUST grab with 44100, 22050 or 11025 ! " ), 2);  	
 		QComboBox_cdda->setCurrentItem( 8 );	
	}
	if ( QCheckBox_cdda_jitter->isChecked() && QComboBox_cdda->currentItem() != 8)
	{
		KMsgBox::message( this, ktr ( "Error" ), ktr ( "If you want to use the software jitter correction\n you MUST grab with 44100 ! " ), 2);  	
 		QComboBox_cdda->setCurrentItem( 8 );	
	}
	if ( !cdda2wav && (QComboBox_cdda->currentItem() != 8) )
	{
		temp  = ktr ( "If you have not cdda2wav, you MUST grab with 44100 !\n" );
		temp += ktr ( "You can find the WEB URL in the Help !" );
		KMsgBox::message( this, ktr ( "Error" ), temp, 2);  	
 		QComboBox_cdda->setCurrentItem( 8 );	
	}
};
bool KrabWidget::QCheckBox_cdda_stereo_clicked()
{
	QString temp;
	if (todolist->grab_mode == 2 && !QCheckBox_cdda_stereo->isChecked() )
	{
		KMsgBox::message( this, ktr ( "Error" ), ktr ( "If you want to use the 8hz-mp3 encoder you MUST enable Stereo ! " ), 2);
		QCheckBox_cdda_stereo->setChecked ( TRUE );
 		return 1;
 	}
	if ( !cdda2wav && !QCheckBox_cdda_stereo->isChecked() )
	{
		temp  = ktr ( "If you have not cdda2wav you MUST enable Stereo ! " );
		temp += ktr ( "You can find the WEB URL in the Help !" );
		KMsgBox::message( this, ktr ( "Error" ), temp, 2);
		QCheckBox_cdda_stereo->setChecked ( TRUE );
 		return 1;
 	}
	QCheckBox_cdda_jitter->setChecked( FALSE );
	return 0;
};
bool KrabWidget::QCheckBox_cdda_16bit_clicked()
{
	QString temp;
	if (todolist->grab_mode == 2 && !QCheckBox_cdda_16bit->isChecked() )
	{
		KMsgBox::message( this, ktr ( "Error" ), ktr ( "The 8hz-mp3 encoder only work with 16bit Audio Data ! " ), 2);
   		QCheckBox_cdda_16bit->setChecked( TRUE );
		return 1;
  	};
	if (todolist->grab_mode == 3 && !QCheckBox_cdda_16bit->isChecked() )
	{
		KMsgBox::message( this, ktr ( "Error" ), ktr ( "The l3enc encoder only work with 16bit Audio Data ! " ), 2);
   		QCheckBox_cdda_16bit->setChecked( TRUE );
		return 1;
  	};
	if (todolist->grab_mode == 5 && !QCheckBox_cdda_16bit->isChecked() )
	{
		KMsgBox::message( this, ktr ( "Error" ), ktr ( "The bladeenc encoder only work with 16bit Audio Data ! " ), 2);
   		QCheckBox_cdda_16bit->setChecked( TRUE );
		return 1;
  	};
	if ( !cdda2wav && !QCheckBox_cdda_16bit->isChecked() )
	{
		temp  =( "You need cdda2wav to grab 8bit Audio Data ! " );
		temp += ktr ( "You can find the WEB URL in the Help !" );
		KMsgBox::message( this, ( "Error" ), temp, 2);
   		QCheckBox_cdda_16bit->setChecked( TRUE );
		return 1;
	};
	QCheckBox_cdda_jitter->setChecked( FALSE );
	return 0;
};
void KrabWidget::QCheckBox_cdda_jitter_clicked()
{
	QCheckBox_cdda_stereo->setChecked( TRUE );
	QCheckBox_cdda_16bit->setChecked( TRUE );
	QComboBox_cdda->setCurrentItem( 8 );
};

void KrabWidget::sorry()
{
	KMsgBox::message( this, ktr ( "Sorry" ), ktr ( "Sorry not yet implemented \n :-(" ) );
};

void KrabWidget::test_enviroment( bool show)
{
	bool temp_cdparanoia,
	     temp_cdda2wav,
	     temp_amp,
	     temp_hz8_mp3,
	     temp_l3enc,
	     temp_bladeenc,
	     temp_mp3enc;

	unsigned int i, mode;
	QString message,
	       possible_devices[25];
	modes [ 0 ] = 0;
	mode = 1;
        possible_devices[0] = "/dev/sg0";
        possible_devices[1] = "/dev/sg1";
        possible_devices[2] = "/dev/sg2";
        possible_devices[3] = "/dev/sg3";
        possible_devices[4] = "/dev/sg4";
        possible_devices[5] = "/dev/sg5";
        possible_devices[6] = "/dev/sg6";
        possible_devices[7] = "/dev/sg7";
        possible_devices[8] = "/dev/sg8";
        possible_devices[9] = "/dev/sg9";
        possible_devices[10] = "/dev/hda";
        possible_devices[11] = "/dev/hdb";
        possible_devices[12] = "/dev/hdc";
        possible_devices[13] = "/dev/hdd";
        possible_devices[14] = "/dev/sga";
        possible_devices[15] = "/dev/sgb";
        possible_devices[16] = "/dev/sgc";
        possible_devices[17] = "/dev/sgd";
        possible_devices[18] = "/dev/sge";
        possible_devices[19] = "/dev/sgf";
        possible_devices[20] = "/dev/sgg";
        possible_devices[21] = "/dev/sgh";
        possible_devices[22] = "/dev/sgi";
        possible_devices[23] = "/dev/sgj";

	message = ktr ( "I have tested your system for required applications:\n\n" );
	QComboBox_device->clear();
	QComboBox_encoder->clear();
	QComboBox_encoder->insertItem( "Wave" );

//	emit( new_status_info("cdparanoia") );
	help_prog_stdout_temp = "";
	help_prog = new KProcess;
	help_prog->clearArguments();
	help_prog->setExecutable( "cdparanoia" );
	connect(help_prog, SIGNAL(receivedStdout(KProcess *, char *, int )), this, SLOT(test_env_stdout(KProcess *, char *, int  ))); 
	connect(help_prog, SIGNAL(receivedStderr(KProcess *, char *, int )), this, SLOT(test_env_stdout(KProcess *, char *, int  )));
 	*help_prog << "-h";
	help_prog->start(KProcess::Block, KProcess::AllOutput );
	delete help_prog;
 	if ( help_prog_stdout_temp.mid(0, 14) == "cdparanoia III" )  
  		temp_cdparanoia = TRUE;
	else 
	{
		temp_cdparanoia = FALSE;
		message += ktr( "cdparanoia is missing\n" );
	};

	help_prog_stdout_temp = "";
	help_prog = new KProcess;
	help_prog->clearArguments();
	help_prog->setExecutable( "cdda2wav" );
	connect(help_prog, SIGNAL(receivedStderr(KProcess *, char *, int )), this, SLOT(test_env_stdout(KProcess *, char *, int  ))); 
 	*help_prog << "-h" ;
	help_prog->start(KProcess::Block, KProcess::AllOutput );
	delete help_prog;
 	if ( help_prog_stdout_temp.mid(0, 8) == "cdda2wav"  )
  		temp_cdda2wav = TRUE;
	else 
	{
		temp_cdda2wav = FALSE;
		message += ktr( "cdda2wav is missing\n" );
	};

	help_prog_stdout_temp = "";
	help_prog = new KProcess;
	help_prog->clearArguments();
	help_prog->setExecutable( "amp" );
	connect(help_prog, SIGNAL(receivedStdout(KProcess *, char *, int )), this, SLOT(test_env_stdout(KProcess *, char *, int  ))); 
	connect(help_prog, SIGNAL(receivedStderr(KProcess *, char *, int )), this, SLOT(test_env_stdout(KProcess *, char *, int  ))); 
 	*help_prog << "-h" ;
	help_prog->start(KProcess::Block, KProcess::AllOutput );
	delete help_prog;
 	if ( help_prog_stdout_temp.mid(0, 6) == "usage:" 
		 		|| help_prog_stdout_temp.mid(4, 6) == "usage:" )
  		temp_amp = TRUE;
	else 
	{
		temp_amp = FALSE;
		message += ktr( "amp is missing\n" );
	};

	help_prog_stdout_temp = "";
	help_prog = new KProcess;
	help_prog->clearArguments();
	help_prog->setExecutable( "8hz-mp3" );
	connect(help_prog, SIGNAL(receivedStderr(KProcess *, char *, int )), this, SLOT(test_env_stdout(KProcess *, char *, int  ))); 
 	*help_prog << "-h" ;
	help_prog->start(KProcess::Block, KProcess::AllOutput );
	delete help_prog;
 	if ( help_prog_stdout_temp.mid(0, 7) == "8hz-mp3"  )
	{
		modes [ mode ] = 2;
		mode++;
  		temp_hz8_mp3 = TRUE;
		QComboBox_encoder->insertItem( ktr( "8hz-mp3" ) );
	}
	else 
	{
		temp_hz8_mp3 = FALSE;
		message +=  ktr( "8hz-mp3 is missing\n" );
	};

	help_prog_stdout_temp = "";
	help_prog = new KProcess;
	help_prog->clearArguments();
	help_prog->setExecutable( KApplication::kde_datadir() + "/krabber/bins/bladeenc.start" );
	connect(help_prog, SIGNAL(receivedStdout(KProcess *, char *, int )), this, SLOT(test_env_stdout(KProcess *, char *, int  ))); 
	help_prog->start(KProcess::Block, KProcess::AllOutput );
	delete help_prog;
 	if ( help_prog_stdout_temp.mid(1, 5) == "Blade"  )
	{
		modes [ mode ] = 5;
		mode++;
  		temp_bladeenc = TRUE;
		QComboBox_encoder->insertItem( ktr( "bladeenc" ) );
	}
	else 
	{
		temp_bladeenc = FALSE;
		message +=  ktr( "bladeenc is missing\n" );
	};

	help_prog_stdout_temp = "";
	help_prog = new KProcess;
	help_prog->clearArguments();
	help_prog->setExecutable( "l3enc" );
	connect(help_prog, SIGNAL(receivedStderr(KProcess *, char *, int )), this, SLOT(test_env_stdout(KProcess *, char *, int  ))); 
 	*help_prog << "-h" ;
	help_prog->start(KProcess::Block, KProcess::AllOutput );
	delete help_prog;
 	if ( help_prog_stdout_temp.mid(2, 13) == "****  L3ENC V"  )
  	{
		modes [ mode ] = 3;
		mode++;
		temp_l3enc = TRUE;
		QComboBox_encoder->insertItem( ktr( "l3enc" ) );
	}
	else 
	{
		temp_l3enc = FALSE;
		message += ktr( "l3enc is missing\n" );
	};

	help_prog_stdout_temp = "";
	help_prog = new KProcess;
	help_prog->clearArguments();
	help_prog->setExecutable( "mp3enc" );
	connect(help_prog, SIGNAL(receivedStdout(KProcess *, char *, int )), this, SLOT(test_env_stdout(KProcess *, char *, int  ))); 
	*help_prog << "-h" ;
	help_prog->start(KProcess::Block, KProcess::AllOutput );
	delete help_prog;
 	if ( help_prog_stdout_temp.mid(0, 2) == "-v"  )
	{
		modes [ mode ] = 4;
		mode++;
  		temp_mp3enc = TRUE;
		QComboBox_encoder->insertItem( ktr( "mp3enc" ) );
	}
	else 
	{
		temp_mp3enc = FALSE;
		message += ktr( "mp3enc is missing\n" );
	};

	if ( temp_cdparanoia )
	{
		devices_count = 0;
		for ( i = 0; i < 24; i++)
		{
			help_prog_stdout_temp = "";
			help_prog = new KProcess;
			help_prog->clearArguments();
			help_prog->setExecutable( "cdparanoia" );
			connect(help_prog, SIGNAL(receivedStdout(KProcess *, char *, int )), this, SLOT(test_env_stdout(KProcess *, char *, int  ))); 
			connect(help_prog, SIGNAL(receivedStderr(KProcess *, char *, int )), this, SLOT(test_env_stdout(KProcess *, char *, int  )));
 			*help_prog << "-Q" << "-d" << possible_devices[ i ];
			help_prog->start(KProcess::Block, KProcess::AllOutput );
			delete help_prog;
 			if ( help_prog_stdout_temp.mid(251, 5) == "track" || help_prog_stdout_temp.mid(250, 6) == "header" 
 					|| help_prog_stdout_temp.mid(253, 20) == "Cdparanoia could not" ) //alpha7
 			{
				cdparanoia_version = 7;
	 		        devices_count++;
				devices[devices_count] = possible_devices[ i ];
				QComboBox_device->insertItem( possible_devices[ i ] );
			};
			if ( help_prog_stdout_temp.mid(254, 5) == "track" || help_prog_stdout_temp.mid(252, 4) == "head"
					|| help_prog_stdout_temp.mid(255, 20) == "Cdparanoia could not") //alpha 8 or 9
 			{
				cdparanoia_version = 8;
	 		        devices_count++;
				devices[devices_count] = possible_devices[ i ];
				QComboBox_device->insertItem( possible_devices[ i ] );
			};
			if ( help_prog_stdout_temp.mid(419, 5) == "track" || help_prog_stdout_temp.mid(417, 4) == "head"
					|| help_prog_stdout_temp.mid(420, 20) == "Cdparanoia could not") //alpha 9 on special devices
 			{
				cdparanoia_version = 9;
	 		        devices_count++;
				devices[devices_count] = possible_devices[ i ];
				QComboBox_device->insertItem( possible_devices[ i ] );
			};
		};	
		if ( devices_count == 0 )
		{
			message += ktr( "No CD-ROM/WORM devices found.\n" );
			QComboBox_device->insertItem( ktr( "No devices found" ) );
		}
	};

	message += "\n\n";
	if ( temp_cdparanoia && temp_cdda2wav  && temp_amp && temp_hz8_mp3 && temp_l3enc && temp_mp3enc && temp_bladeenc && devices_count != 0 )
		message += ktr( " All applications has been found :-) \n " );
	else
	{
		if ( !temp_cdparanoia || devices_count == 0 ) 
			message += ktr (" You can NOT grab audio cds :-(\n" );
			else if ( !cdda2wav )
				message +=ktr(" You can ONLY grab audio cds at 44.1 khz, stereo, 16bit.\n");
	   	if ( !temp_amp ) 
			message += ktr (" You can NOT decode mp2 or mp3 files to wav\n   or mp3(with a different bitrate) again :-(\n");  	
		if ( !temp_hz8_mp3 && !temp_bladeenc && !temp_l3enc && !temp_mp3enc )
			message += ktr (" You can NOT produce mp3 files (only WAV output)\n   go and get the FREE 8hz-mp3 encoder (look in the help for the WEB Site)\n" );  	
		if (  !temp_cdparanoia  && !temp_amp && !temp_hz8_mp3 && !temp_bladeenc && !temp_l3enc && !temp_mp3enc )
	   		message += ktr ("!!! THIS APPLICATION CAN NOT DO ANYTHING !!! \n !!! GO AND GET SOME REQUIRED APPS !!!\n" );
		if ( (devices_count != 0) && temp_cdparanoia && temp_amp && ( temp_hz8_mp3 || temp_bladeenc || temp_l3enc || temp_mp3enc ) )
 			message += ktr ("Not all supported applications has been found, but you can handle all files/media :-)\n" );
	}; 	
	if (show || temp_cdparanoia!=cdparanoia || temp_cdda2wav!=cdda2wav || temp_amp!=amp || temp_hz8_mp3!=hz8_mp3 || temp_bladeenc!=bladeenc || temp_l3enc!=l3enc || temp_mp3enc!=mp3enc )
	{
	 	KMsgBox::message( this, ktr ("System Check"), message);	
		cdparanoia = temp_cdparanoia;
		cdda2wav = temp_cdda2wav;
		amp = temp_amp;
		hz8_mp3 = temp_hz8_mp3;
		bladeenc = temp_bladeenc;
		l3enc = temp_l3enc;
		mp3enc = temp_mp3enc;
	};
};
void KrabWidget::test_env_stdout(KProcess *, char *buffer, int buffer_size) 
{
	QString row;
        QString temp;
        temp = buffer;
        if (buffer_size > 1023)
        {
                help_prog_stdout_temp = help_prog_stdout_temp + temp.mid(0, 1024);
        }
        else
        {
                help_prog_stdout_temp = help_prog_stdout_temp + temp.mid(0, (buffer_size - 1));
	};
};                                               

void KrabWidget::krabwidget_setEnabled( bool flag )
{
	emit enable_widgets( flag );

	KSlider_nice->setEnabled( flag );
	KSlider_smp->setEnabled( flag );
	QComboBox_encoder->setEnabled( flag );
	QComboBox_cdda->setEnabled( flag );
	QComboBox_device->setEnabled( flag );
	QCheckBox_mp3_header->setEnabled( flag );
	QCheckBox_cdda_16bit->setEnabled( flag );
	QCheckBox_cdda_jitter->setEnabled( flag );
	QCheckBox_cdda_stereo->setEnabled( flag );
	QLabel_smp->setEnabled( flag );
	QLabel_nice->setEnabled( flag );
	
	if ( flag )
	{
		QPushButton_cd->setPixmap( *pix_push_1 );
		QPushButton_outputpath->setPixmap( *pix_push_2 );
		QPushButton_names->setPixmap( *pix_push_3 );
		QPushButton_doit->setPixmap( *pix_push_4 );
	}
	else
	{
		QPushButton_cd->setPixmap( *pix_push_1_off );
		QPushButton_outputpath->setPixmap( *pix_push_2_off );
		QPushButton_names->setPixmap( *pix_push_3_off );
		QPushButton_doit->setPixmap( *pix_push_4_off );
		
	};
	QPushButton_cd->blockSignals( !flag );
	QPushButton_outputpath->blockSignals( !flag );
	QPushButton_names->blockSignals( !flag );
	QPushButton_doit->blockSignals( !flag );
	KTabListBox_todo->blockSignals( !flag );

	if ( todolist->grab_mode == 0 )
	{
		QCheckBox_wav_raw->setEnabled( flag );
	};
	if ( todolist->grab_mode == 2 )
	{
		QComboBox_8hz_br->setEnabled( flag );
		QCheckBox_8hz_copyright->setEnabled( flag );
		QCheckBox_8hz_original->setEnabled( flag );
	};
	if ( todolist->grab_mode == 5 )
	{
		QComboBox_blade_br->setEnabled( flag );
		QCheckBox_blade_copyright->setEnabled( flag );
		QCheckBox_blade_private->setEnabled( flag );
		QCheckBox_blade_crc->setEnabled( flag );
	};
	if ( todolist->grab_mode == 3 )
	{
		QComboBox_l3_br->setEnabled( flag );
		QCheckBox_l3_hq->setEnabled( flag );
		QCheckBox_l3_crc->setEnabled( flag );
		QCheckBox_l3_speech->setEnabled( flag );
	};
	if ( todolist->grab_mode == 4 )
	{
		QComboBox_mp3_br->setEnabled( flag );
		QComboBox_mp3_ql->setEnabled( flag );
	};
};

void KrabWidget::QComboBox_encoder_clicked(int n)
{
	if ( todolist->grab_mode == 0 && QCheckBox_wav_raw != NULL)
	{
		kconfig->writeEntry( "wav_data_raw", QCheckBox_wav_raw->isChecked() );
		initLayout_wav_del();
	};
	if ( todolist->grab_mode == 2 )
	{
		kconfig->writeEntry( "8hz_enc_br", QComboBox_8hz_br->currentItem() );
		kconfig->writeEntry( "8hz_enc_copyright", QCheckBox_8hz_copyright->isChecked() );
		kconfig->writeEntry( "8hz_enc_original", QCheckBox_8hz_original->isChecked() );
		initLayout_8hz_del();
	};
	if ( todolist->grab_mode == 3 )
	{
		kconfig->writeEntry( "l3_enc_br", QComboBox_l3_br->currentItem() );
		kconfig->writeEntry( "l3_enc_hq", QCheckBox_l3_hq->isChecked() );
		kconfig->writeEntry( "l3_enc_speech", QCheckBox_l3_speech->isChecked() );
		kconfig->writeEntry( "l3_enc_crc", QCheckBox_l3_crc->isChecked() );
		initLayout_l3_del();
	};
	if ( todolist->grab_mode == 4 )
	{
		kconfig->writeEntry( "mp3_enc_br", QComboBox_mp3_br->currentItem() );
		kconfig->writeEntry( "mp3_enc_ql", QComboBox_mp3_ql->currentItem() );
		initLayout_mp3_del();
	};
	if ( todolist->grab_mode == 5 )
	{
		kconfig->writeEntry( "blade_enc_br", QComboBox_blade_br->currentItem() );
		kconfig->writeEntry( "blade_enc_copyright", QCheckBox_blade_copyright->isChecked() );
		kconfig->writeEntry( "blade_enc_private", QCheckBox_blade_private->isChecked() );
		kconfig->writeEntry( "blade_enc_crc", QCheckBox_blade_crc->isChecked() );
		initLayout_blade_del();
	};
	kconfig->sync();

	switch ( modes[ n ] )
	{
	case 0 :
		todolist->grab_mode = 0;
		initLayout_wav();
		QCheckBox_wav_raw->setChecked( kconfig->readBoolEntry( "wav_data_raw", FALSE ) );
		break;
	case 2 :
		todolist->grab_mode = 2;
		QCheckBox_cdda_stereo->setChecked( TRUE );
		QCheckBox_cdda_16bit->setChecked( TRUE );
		QComboBox_cdda->setCurrentItem( 8 );
		initLayout_8hz();
		QComboBox_8hz_br->setCurrentItem( kconfig->readNumEntry( "8hz_enc_br", 8) );
		QCheckBox_8hz_copyright->setChecked( kconfig->readBoolEntry( "8hz_enc_copyright", FALSE ) );
		QCheckBox_8hz_original->setChecked( kconfig->readBoolEntry( "8hz_enc_original", FALSE ) );
		break;
	case 3 :
		todolist->grab_mode = 3;
		initLayout_l3();
		QComboBox_l3_br->setCurrentItem( kconfig->readNumEntry( "l3_enc_br", 5) );
		QCheckBox_l3_hq->setChecked( kconfig->readBoolEntry( "l3_enc_hq", FALSE ) );
		QCheckBox_l3_speech->setChecked( kconfig->readBoolEntry( "l3_enc_speech", FALSE ) );
		QCheckBox_l3_crc->setChecked( kconfig->readBoolEntry( "l3_enc_crc", FALSE ) );
		break;
	case 4 :
		todolist->grab_mode = 4;
		initLayout_mp3();
		QComboBox_mp3_br->setCurrentItem( kconfig->readNumEntry( "mp3_enc_br", 9) );
		QComboBox_mp3_ql->setCurrentItem( kconfig->readNumEntry( "mp3_enc_ql", 3) );
		break;
	case 5 :
		todolist->grab_mode = 5;
		initLayout_blade();
		QComboBox_blade_br->setCurrentItem( kconfig->readNumEntry( "blade_enc_br", 8) );
		QCheckBox_blade_copyright->setChecked( kconfig->readBoolEntry( "blade_enc_copyright", FALSE ) );
		QCheckBox_blade_private->setChecked( kconfig->readBoolEntry( "blade_enc_private", FALSE ) );
		QCheckBox_blade_crc->setChecked( kconfig->readBoolEntry( "blade_enc_crc", FALSE ) );
		break;
	};
};
void KrabWidget::delete_job( unsigned int nr )
{
	unsigned int i;

	for ( i = nr; i < todolist->tracks; i++)
	{
		todolist->device[i] 		= todolist->device[i+1];
		todolist->time[i]   		= todolist->time[i+1];
 		todolist->group[i] 		= todolist->group[i+1];
 		todolist->album[i]		= todolist->album[i+1]; 
		todolist->title[i] 		= todolist->title[i+1]; 
		todolist->year[i] 		= todolist->year[i+1];
		todolist->comment[i] 		= todolist->comment[i+1];
 		todolist->output_filename[i]	= todolist->output_filename[i+1]; 
		todolist->music_type[i] 	= todolist->music_type[i+1];
		todolist->type[i] 		= todolist->type[i+1];
 		todolist->tracknumber[i]	= todolist->tracknumber[i+1];
		todolist->nodes[i] 		= todolist->nodes[i+1];
 	};
	todolist->tracks--;
};

const unsigned int KrabWidget::bitrate_8hz[]   = { 32,40,48,56,64,80,96,112,128,160,192,224,256,320 };
const unsigned int KrabWidget::bitrate_blade[] = { 32,40,48,56,64,80,96,112,128,160,192,224,256,320 };
const unsigned int KrabWidget::bitrate_l3[]    = { 32,56,64,96,112,128,192,256 };
const unsigned int KrabWidget::bitrate_mp3[]   = { 20,24,32,40,48,56,64,96,112,128,160,192 };
const unsigned int KrabWidget::bitrate_mpeg_layer2[]   = { 0,32,48,56,64,80,96,112,128,160,192,224,256,320,384 };
const unsigned int KrabWidget::bitrate_mpeg_layer3[]   = { 0,32,40,48,56,64,80,96,112,128,160,192,224,256,320 };
const unsigned int KrabWidget::bitrate_8hz_max = 14;
const unsigned int KrabWidget::bitrate_blade_max = 14;
const unsigned int KrabWidget::bitrate_l3_max = 8;
const unsigned int KrabWidget::bitrate_mp3_max = 12;


